package madynes.flowoid;

import java.util.ArrayList;

import madynes.flowoid.exporter.Driver;
import madynes.flowoid.exporter.ExporterService;
import madynes.flowoid.exporter.R;
import android.app.ListActivity;
import android.os.Bundle;
import android.widget.ArrayAdapter;
import android.widget.ListView;

public class StatsActivity extends ListActivity {
 
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		ArrayList<String> stats = new ArrayList<String>();

		stats.add(ExporterService.getStatConnectedDrivers() + " " + getString(R.string.statsDriversConnected));
		stats.add(ExporterService.getStatActiveNetflows() + " " + getString(R.string.statsActiveNetflows));
		stats.add(ExporterService.getStatNetflowsWaitingToBeExported() + " " + getString(R.string.statsNetflowsWaiting));
		stats.add(ExporterService.getStatExportedNetFlows() + " " + getString(R.string.statsNetflowsExported));
		stats.add(ExporterService.getStatExportedPackets() + " " + getString(R.string.statsPacketsExported));
		stats.add(ExporterService.getStatSniffedPackets() + " " + getString(R.string.statsPacketsSniffed));
		stats.add(ExporterService.getStatUnrecognizedSniffedPackets() + " " + getString(R.string.statsPacketsUnrecognized));
		stats.add(ExporterService.getStatFailedSniffedPackets() + " " + getString(R.string.statsPacketsFailed));
		stats.add(Connectivity.getStatNeworkRestarts() + " " + getString(R.string.statsNeworkRestarts));
		stats.add(Driver.getStatDriverFails() + " " + getString(R.string.statsDriverFails));
		
		setListAdapter(new ArrayAdapter<String>(this, R.layout.stats, stats));
 
		ListView listView = getListView();
		listView.setTextFilterEnabled(true);
	}
}