package madynes.flowoid.exporterImpl;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

import madynes.flowoid.exporter.DataField;

public class FieldIPProtocol extends DataField {
	private short value;
	
	// From /etc/protocols
	public static enum IPProtocol {
		ICMP 			(1),
		IGMP 			(2),
		GGP 			(3),
		IPENCAP			(4),
		ST 				(5),
		TCP 			(6),
		EGP 			(8),
		IGP 			(9),
		PUP 			(12),
		UDP 			(17),
		HMP 			(20),
		XNS_IDP 		(22),
		RDP 			(27),
		ISO_TP4 		(29),
		DCCP			(33),
		XTP 			(36),
		DDP 			(37),
		IDPR_CMTP 		(38),
		IPV6 			(41),
		IPV6_ROUTE 		(43),
		IPV6_FRAG 		(44),
		IDRP 			(45),
		RSVP 			(46),
		GRE				(47),
		ESP				(50),
		AH				(51),
		SKIP			(57),
		IPV6_ICMP		(58),
		IPV6_NONXT		(59),
		IPV6_OPTS		(60),
		RSPF			(73),
		VMTP			(81),
		EIGRP			(88),
		OSPF			(89),
		AX_25			(93),
		IPIP			(94),
		ETHERIP 		(97),
		ENCAP 			(98),
		PIM 			(103),
		IPCOMP 			(108),
		VRRP 			(112),
		L2TP 			(115),
		ISIS 			(124),
		SCTP 			(132),
		FC 				(133),
		MOBILITY_HEADER (135),
		UDPLITE 		(136),
		MPLS_IN_IP 		(137),
		MANET 			(138),
		HIP 			(139),
		SHIM6 			(140),
		WESP 			(141),
		ROHC 			(142);	
		
		private int value;
		
		IPProtocol(int value) {
			this.value = value;
		}
		
		public int getValue() {
			return value;
		}
	}
	
	public FieldIPProtocol(IPProtocol protocol) {
		value = (short) protocol.getValue();
	}

	@Override
	public void onInit(byte[] headers) {}

	@Override
	public void onUpdate(byte[] headers) {}

	@Override
	public void onExport(byte[] headers) {}
	
	@Override
	public ByteBuffer getValue() {
		ByteBuffer bytes = getByteBuffer();
		
    	ByteBuffer valueBytes = ByteBuffer.allocate(2);
    	valueBytes.order(ByteOrder.LITTLE_ENDIAN);
    	valueBytes.putShort(value);

		bytes.put(valueBytes.get(0));

    	return bytes;
	}
}
