package madynes.flowoid.exporterImpl;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

import madynes.flowoid.exporter.DataField;

public class FieldIPVersion extends DataField {
	private short value;
	
	public static enum IPVersion {
		IPV4 (4),
		IPV6 (6);
		
		private int value;
		
		IPVersion(int value) {
			this.value = value;
		}
		
		public int getValue() {
			return value;
		}
	}
	
	public FieldIPVersion(IPVersion version) {
		value = (short) version.getValue();
	}

	@Override
	public void onInit(byte[] headers) {}

	@Override
	public void onUpdate(byte[] headers) {}

	@Override
	public void onExport(byte[] headers) {}
	
	@Override
	public ByteBuffer getValue() {
		ByteBuffer bytes = getByteBuffer();
		
    	ByteBuffer valueBytes = ByteBuffer.allocate(2);
    	valueBytes.order(ByteOrder.LITTLE_ENDIAN);
    	valueBytes.putShort(value);

		bytes.put(valueBytes.get(0));

    	return bytes;
	}
}
