package madynes.flowoid.exporterImpl;

import java.nio.ByteBuffer;

import madynes.flowoid.LocationFinder;
import madynes.flowoid.exporter.DataField;

public class FieldLocLatDec extends DataField {
	private long value;
	private LocationFinder location;
	
	public FieldLocLatDec(LocationFinder location) {
		this.location = location;
	}

	@Override
	public void onInit(byte[] headers) {
		double latitude = location.getLatitude();
		
		if(((int) latitude) != latitude)
			value = Long.parseLong(String.valueOf(latitude).split("\\.")[1]);
		else
			value = 0;
	}

	@Override
	public void onUpdate(byte[] headers) {}

	@Override
	public void onExport(byte[] headers) {}
	
	@Override
	public ByteBuffer getValue() {
		ByteBuffer bytes = getByteBuffer();
		
		bytes.putLong(value);

    	return bytes;
	}
}
